
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Grn_linesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const grn_lines = await db.grn_lines.create(
            {
                id: data.id || undefined,
        
        quantity_received: data.quantity_received
        ||
        null
            ,
            
        quantity_rejected: data.quantity_rejected
        ||
        null
            ,
            
        remarks: data.remarks
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await grn_lines.setTenant( data.tenant || null, {
            transaction,
        });
        
        await grn_lines.setGoods_receipt_note( data.goods_receipt_note || null, {
            transaction,
        });
        
        await grn_lines.setPo_line( data.po_line || null, {
            transaction,
        });
        
        await grn_lines.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return grn_lines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const grn_linesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                quantity_received: item.quantity_received
            ||
            null
            ,
            
                quantity_rejected: item.quantity_rejected
            ||
            null
            ,
            
                remarks: item.remarks
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const grn_lines = await db.grn_lines.bulkCreate(grn_linesData, { transaction });

        // For each item created, replace relation files
        

        return grn_lines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const grn_lines = await db.grn_lines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.quantity_received !== undefined) updatePayload.quantity_received = data.quantity_received;
        
        
        if (data.quantity_rejected !== undefined) updatePayload.quantity_rejected = data.quantity_rejected;
        
        
        if (data.remarks !== undefined) updatePayload.remarks = data.remarks;
        
        
        updatePayload.updatedById = currentUser.id;

        await grn_lines.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await grn_lines.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.goods_receipt_note !== undefined) {
            await grn_lines.setGoods_receipt_note(
              
              data.goods_receipt_note,
              
              { transaction }
            );
        }
        
        if (data.po_line !== undefined) {
            await grn_lines.setPo_line(
              
              data.po_line,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await grn_lines.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return grn_lines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const grn_lines = await db.grn_lines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of grn_lines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of grn_lines) {
                await record.destroy({transaction});
            }
        });


        return grn_lines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const grn_lines = await db.grn_lines.findByPk(id, options);

        await grn_lines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await grn_lines.destroy({
            transaction
        });

        return grn_lines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const grn_lines = await db.grn_lines.findOne(
            { where },
            { transaction },
        );

        if (!grn_lines) {
            return grn_lines;
        }

        const output = grn_lines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await grn_lines.getTenant({
            transaction
        });
        
        
        output.goods_receipt_note = await grn_lines.getGoods_receipt_note({
            transaction
        });
        
        
        output.po_line = await grn_lines.getPo_line({
            transaction
        });
        
        
        output.organizations = await grn_lines.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.goods_receipt_notes,
        as: 'goods_receipt_note',
        
        where: filter.goods_receipt_note ? {
          [Op.or]: [
            { id: { [Op.in]: filter.goods_receipt_note.split('|').map(term => Utils.uuid(term)) } },
            {
              grn_number: {
                [Op.or]: filter.goods_receipt_note.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.po_lines,
        as: 'po_line',
        
        where: filter.po_line ? {
          [Op.or]: [
            { id: { [Op.in]: filter.po_line.split('|').map(term => Utils.uuid(term)) } },
            {
              item_name: {
                [Op.or]: filter.po_line.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.remarks) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'grn_lines',
                        'remarks',
                        filter.remarks,
                    ),
                };
            }
            

            
            

            
            if (filter.quantity_receivedRange) {
                const [start, end] = filter.quantity_receivedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_received: {
                    ...where.quantity_received,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_received: {
                    ...where.quantity_received,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.quantity_rejectedRange) {
                const [start, end] = filter.quantity_rejectedRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity_rejected: {
                    ...where.quantity_rejected,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity_rejected: {
                    ...where.quantity_rejected,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.grn_lines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'grn_lines',
                        'remarks',
                        query,
                    ),
                ],
            };
        }

        const records = await db.grn_lines.findAll({
            attributes: [ 'id', 'remarks' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['remarks', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.remarks,
        }));
    }

    
};

